"use strict";

(function (global) {

    var DLTemplate = React.createClass({
        displayName: "DLTemplate",

        triggerDL: function triggerDL() {

            this.setState({ downloadStarted: true });
            global.setTimeout((function () {
                this.props.pydio.Controller.fireAction("download");
                global.setTimeout((function () {
                    this.setState({ downloadStarted: false });
                }).bind(this), 1500);
            }).bind(this), 100);
        },

        detectFirstNode: function detectFirstNode() {
            var dm = this.props.pydio.getContextHolder();
            if (!dm.getSelectedNodes().length) {
                var first = dm.getRootNode().getFirstChildIfExists();
                if (first) {
                    dm.setSelectedNodes([first], "dataModel");
                    this.setState({ node: first });
                } else {
                    global.setTimeout(this.detectFirstNode.bind(this), 1000);
                }
            } else {
                if (!this.state || !this.state.node) {
                    this.setState({ node: dm.getSelectedNodes()[0] });
                }
            }
        },

        componentDidMount: function componentDidMount() {
            this.detectFirstNode();
            var pydio = this.props.pydio;
            if (pydio.user && pydio.user.activeRepository) {
                this.setState({
                    repoObject: pydio.user.repositories.get(pydio.user.activeRepository)
                });
            } else {
                global.document.observe("ajaxplorer:repository_list_refreshed", (function (e) {
                    var repositoryList = e.memo.list;
                    var repositoryId = e.memo.active;
                    if (repositoryList && repositoryList.has(repositoryId)) {
                        var repoObject = repositoryList.get(repositoryId);
                        this.setState({ repoObject: repoObject });
                    }
                }).bind(this));
            }
        },

        render: function render() {

            if (!this.props.pydio.user) {
                return React.createElement("div", null);
            }
            var name1 = undefined,
                name2 = undefined,
                name3 = undefined,
                owner = undefined;
            var classNames = ['download-block'];
            if (this.state && this.state.repoObject) {
                owner = this.state.repoObject.getOwner();
                name1 = '%1 shared'.replace('%1', owner);
                name2 = this.state.repoObject.getLabel();
                name3 = 'with you';
            }
            var click = null;
            var fileDetails = React.createElement(
                "div",
                { className: "dl-details" },
                this.props.pydio.MessageHash[466]
            );
            if (this.state && this.state.node) {
                click = this.triggerDL.bind(this);
                fileDetails = React.createElement(
                    "div",
                    { className: "dl-details" },
                    React.createElement(
                        "div",
                        { className: "row" },
                        React.createElement(
                            "span",
                            { className: "label" },
                            this.props.pydio.MessageHash[503]
                        ),
                        React.createElement(
                            "span",
                            { className: "value" },
                            this.state.node.getMetadata().get('filesize')
                        )
                    ),
                    React.createElement(
                        "div",
                        { className: "click-legend" },
                        this.props.pydio.MessageHash['share_center.231']
                    )
                );
            } else {
                classNames.push('not-ready');
            }
            if (this.state && this.state.downloadStarted) {
                classNames.push('dl-started');
            }
            return React.createElement(
                "div",
                { className: classNames.join(' '), onClick: click },
                React.createElement(
                    "span",
                    { className: "dl-filename" },
                    name2
                ),
                React.createElement(
                    "div",
                    { className: "dl-icon" },
                    React.createElement("span", { className: "mdi mdi-file" }),
                    React.createElement("span", { className: "mdi mdi-download" })
                ),
                fileDetails
            );
        }

    });

    var ns = global.ShareTemplates || {};
    ns.DLTemplate = DLTemplate;
    global.ShareTemplates = ns;
})(window);
